use utf8;

+{
	v5.005 => {
		new => [
			['threads' => '', {experimental => 0, stable => 0}],
			['<code>B::…</code>', 'backend hooks'],
			['<code>qr//</code>' => 'overhauled regular expression engine: precompile operator, lookahead/behind, code, conditions, localised flags'],
			['<code>… foreach</code>' => '<code>for(each)</code> as statement modifier, with large ranges optimised as counting loops'],
			['<code>…::</code>' => 'implicitly quoted package name'],
			['<code>ref $@</code>' => '<code>die</code> passes reference values to exception handlers'],
			['<code>INIT {}</code>', 'subs run just before the perl runtime begins execution'],
			['<code>tie @…</code>' => 'base class for <code>TIEARRAY</code> implementations, and generally improved supported of tied handlers'],
			['<code>substr …,…,…,$replace</code>', 'replacement string in 4th argument'],
			['<code>splice …,…,-$length</code>', 'negative length indicates elements to keep at the end of an array'],
			['<code>$/</code>', 'integer or scalar separator makes <code>&lt;&gt;</code> read records instead of lines'],
		],
		release => '1998-07-22',
		unstable => 0,
	},

	v5.6 => {
		new => [
			['<code>use warnings</code>', 'pragma to enable warnings in lexical scope'],
			['<code>use utf8</code>', 'experimental unicode semantics <small>(completed in v5.8)</small>', {experimental => 0, stable => v5.8}],
			['<code>use charnames</code>', 'string escape <code>\N{}</code> to insert named character'],
			['<code>our</code>', 'declare global variables'],
			['<code>v1.2.3</code>', q"represent strings as vector of ordinals, useful in version numbers (<code>printf '%vd'</code> to display)"],
			['<code>0b0</code>', q"binary numbers in literals, <code>printf '%b'</code>, and <code>oct</code>"],
			['<code>sub :lvalue</code>', 'subroutine attribute to return a modifiable value', {experimental => 0, stable => v5.20}],
#			['<code>sub :locked :method</code>', 'syntax to declare subroutine attributes'], # can be inferred from :lvalue support
			['<code>open my $fh, $mode, $expr</code>', 'file handles in scoped scalars, third argument for unambiguous file name'],
			[q"<code>pack 'q'</code>", '64-bit integer support (also large files &gt;2GiB)', {experimental => 0, stable => v5.8.1}],
			['<code>sort $coderef ()</code>', 'comparison function can be a subroutine reference; prototype <code>($$)</code> to pass elements as normal <code>@_</code>'],
			['<code>CHECK {}</code>', 'special block called at end of compilation'],
			['<code>/[[:…:]]/</code>', 'POSIX character class syntax such as <code>/[[:alpha:]]/</code>'],
			# quite a lot more, but leave it at this
		],
		release => '2000-03-23',
		distro => {
			debian => 'woody',
			rhel => '2', # v5.6.0; also in red hat 7.0
			solaris => '9', # v5.6.1; 2002-05 eol 2014-10
			aix => '5.1', # 2001-05 eol 2006-04
			opensuse => '7.1',
		},
		unicode => '3.0.1',
	},

	v5.8 => {
		new => [
			[q"<code>no utf8</code>", 'full unicode support, <code>utf8</code> pragma only for script encoding'],
			[q"<code>binmode $fh, ':perlio'</code>", 'file handle behaviour altered by PerlIO layers'],
			[q"<code>open $fh, '-|', @cmd</code>", 'open list to fork a command without spawning a shell'],
			[q"<code>open $fh, '>', \$var</code>", 'perl scalars as virtual files'],
			[q"<code>printf '%1$s', @args</code>", 'syntax to use parameters out of order'],
			[q"<code>1_2_3 == 123</code>", 'underscores between digits allowed in numeric constants'],
#			[q"<code>use if</code>", 'conditional module inclusion'], # also installable in earlier versions
		],
		release => '2002-07-18',
		distro => {
			debian => 'sarge',
			rhel => '3', # v5.8.0; v5.8.8 in RHEL6 (2007-2014)
			solaris => '10', # v5.8.4; 2005-01 eol 2021-01
			centos => '3-5', # v5.8.0 in v3 (2004-03); v5.8.8 in v5 (eol 2017-03)
			ubuntu => '4.10',
			aix => '5.2', # v5.8.0; v5.8.2 in 5.3 and 6.1 (eol 2017-04-30)
			freebsd => '4-6',
			opensuse => '8.1',
		},
		distrosum => "dinosaur platforms such as Solaris 10, AIX 5.2, RHEL 3, SLES 8",
		unicode => '3.2.0',
	},

	v5.10 => {
		new => [
			['<code>//</code>', 'defined-or operator'],
			['<code>~~</code>', 'smart-match operator to compare different data types <small>(updated in v5.10.1)</small>', {experimental => 'smartmatch'}],
			['<code>say</code>', 'print with newline, equivalent to <code>print @_, "\n"</code>', {feature => 'say'}],
			['<code>given</code>', 'switch statement to smart-match with <code>when</code>/<code>default</code>', {feature => 'switch', experimental => 'smartmatch'}],
			['<code>/(?&lt;name>)/</code>', 'named capture buffers into <code>%+</code>'],
			['<code>/(?1)/</code>', 'recursive regular expression patterns'],
			['<code>/(?|)/</code>', 'resets capture numbering for each contained branch'],
			['<code>/.++/</code>', 'possessive quantifiers <code>?+</code>, <code>*+</code>, <code>++</code> to match greedily'],
			['<code>s/keep\K//</code>', 'floating positive lookbehind, efficient alternative for <code>s/(keep)/$1/</code>'],
			['<code>/p</code>', 'optionally preserve <code>${^MATCH}</code> variables (avoiding <code>$&</code> penalty until COW in v5.20)'],
			['<code>/\v/, /\h/</code>', 'vertical and horizontal whitespace escapes (<code>\V</code> <code>\H</code> to invert); also <code>/\R/</code> for newlines'],
			['<code>my $_</code>', 'lexically scoped version of the default variable', {experimental => 'lexical_topic', dropped => v5.23.4}],
			['<code>state</code>', 'persistent <code>my</code> variables', {feature => 'state'}],
		],
		release => '2007-12-18',
		distro => {
			debian => 'lenny',
			rhel => '6', # v5.10.1
			centos => '6', # v5.10.1 (2011-07 eol 2020-11)
			ubuntu => '8.10', # v5.10.1 in 10.04 LTS
			aix => '7.1', # v5.10.1 (2010-09 eol 2020?)
			opensuse => '11.0',
		},
		unicode => '5.0.0',
	},

	v5.12 => {
		new => [
			['<code>package</code> version', '<code>package</code> NAME VERSION shorthand for <code>our $VERSION</code>'],
			['<code>...</code>', 'yada-yada operator: code placeholder'],
			['<code>use 5.012</code>', 'implicit <code>strict</code> if use VERSION >= v5.12'],
			['<code>… when</code>', '<code>when</code> is now allowed to be used as a statement modifier'],
			[q"<code>use overload 'qr'</code>", 'customisable conversion to regular expressions'],
			['<code>/\N/</code>', 'inverse \n to match any character except newline regardless of <code>/s</code>', {experimental => 0, stable => v5.18}],
		],
		release => '2010-04-12',
		unicode => '5.2',
		distro => {
			solaris => '11', # also v5.8.4; 2010-11 eol 2024-11
			ubuntu => '11.10',
			freebsd => '7',
			opensuse => '11.3',
		},
	},

	v5.14 => {
		new => [
			['<code>s///r</code>', 'non-destructive substitution'],
			['<code>/(?{ m() })/</code>', 'regular expressions can be nested in <code>/(?{})/</code> and <code>/(??{})/</code>', {experimental => 0, stable => v5.20}],
			['<code>/dalu</code>', 'regexp modifiers to restrict character classes: either <strong>d</strong>efault, <strong>a</strong>scii, <strong>l</strong>ocale, or <strong>u</strong>nicode semantics.'],
			[q"<code>use re '/flags'</code>", 'customise default modifiers'],
			['<code>/(?^)/</code>', 'construct to reset to default modifiers'],
			['<code>each $ref</code> e.a.', 'array and hash container functions accept references', {experimental => 'postderef', dropped => v5.23.1}],
			['<code>FH->method</code>', 'filehandle method calls load IO::File on demand (eg. <code>STDOUT->flush</code>)'],
			['<code>\o{}</code>', 'escape sequence for octal values beyond \777'],
		],
		release => '2011-05-14',
		distro => {
			debian => '7', # wheezy 2013-05 eol 2018-05
			ubuntu => '12.04',
			opensuse => '12.1',
		},
		distrosum => "stable servers such as Debian 7, Ubuntu 12.04, CentOS 7",
		unicode => '6.0+#8',
	},

	v5.16 => {
		new => [
			['<code>__SUB__</code>', 'current subroutine reference', {feature => 'current_sub'}],
			['<code>fc, "\F"</code>', 'unicode foldcase to compare case-insensitively', {feature => 'fc'}],
			['<code>"\N{}"</code>', 'automatic <code>use charnames qw( :full :short )</code>'],
		],
		release => '2012-05-20',
		distro => {
			rhel => '7', # v5.16.3
			centos => '7', # v5.16.3 (2014-07 eol 2024-06)
			freebsd => '9',
			opensuse => '12.2',
		},
		unicode => '6.1',
	},

	v5.18 => {
		new => [
			['<code>${^LAST_FH}</code>', 'last read filehandle (used by <code>$.</code>)'],
			['<code>/(?[ a + b ])/</code>', 'regex set operations (character substraction <code>-</code>, unions <code>&amp;</code>)', {experimental => 'regex_sets'}],
			['<code>my sub</code>', 'lexical subroutines (also <code>state</code>, <code>our</code>); buggy before v5.22', {experimental => 'lexical_subs', stable => v5.26}],
			['<code>next $expression</code>', 'loop controls allow runtime expressions'],
			[q"<code>no warnings 'experimental::…'</code>", 'mechanism for experimental features, as of now required for <em>smartmatch</em>'],
		],
		release => '2013-05-18',
		distro => {
			ubuntu => '14.04 LTS', # trusty
			opensuse => '13.1',
		},
		unicode => '6.2',
	},

	v5.20 => {
		new => [
			['<code>sub ($var)</code>', 'subroutine signatures', {feature => 'signatures', experimental => 'signatures'}],
			['<code>%hash{…}</code>', 'hash slices return key+value pairs'],
			['<code>[]->@*</code>', 'postfix dereferencing (also e.g. <code>$scalar->$*</code> for <code>$$scalar</code>)', {feature => 'postderef, postderef_qq', experimental => 'postderef', stable => v5.23.1}],
			[q"<code>use warnings 'once'; $a</code>", 'variables $a and $b are exempt from <em>used once</em> warnings'],
		],
		unicode => '6.3',
		release => '2014-05-27',
		distro => {
			debian => '8', # jessie 2015-04 eol 2020-05
			ubuntu => '14.10', # utopic
			aix => '7.2',
			opensuse => '13.2', # 2014-11 eol 2017-01
		},
		distrosum => "stable servers such as Debian 8 (oldstable), Ubuntu 14.10, FreeBSD 10, openSUSE 13.2",
	},

	v5.22 => {
		new => [
			['<code>\$alias =</code>', 'aliasing via reference (scoped as of v5.25.3)', {experimental => 'refaliasing'}],
			['<code>&lt;&lt;>></code>', 'safe <code>readline</code> ignoring open flags in arguments'],
			['<code>/()/n</code>', 'flag to disable numbered capturing, turning <code>()</code> into <code>(?:)</code>'],
			['<code>/\b{}/</code>', 'boundary types: <em>gcb</em> (grapheme cluster), <em>sb</em> (sentence), <em>wb</em> (word)'],
			['<code>&.</code>', '<code>& | ^ ~</code> consistently numeric, dotted operators for strings', {feature => 'bitwise', experimental => 'bitwise', stable => v5.28}],
			[q"<code>use re 'strict'</code>", 'apply stricter syntax rules to regular expression patterns', {experimental => 're_strict'}],
			['<code>0x.beep+0</code>', q"hexadecimal floating point notation with binary power; <code>printf '%a'</code> to display"],
			['<code><s>??</s></code>', 'single match shorthand (deprecated since v5.14) requires the operator <code><em>m</em>?PATTERN?</code>'],
		],
		unicode => '7.0',
		release => '2015-06-01',
		distro => {
			ubuntu => '16.04 LTS', # xenial
		},
	},

	v5.24 => {
		new => [
			[q"<code>printf '%.*2$x'</code>", 'reordered precision arguments'],
			['<code>/\b{lb}/</code>', 'line break boundary type (position suitable for hyphenation)'],
			['<code>/faster/</code>', 'various significant speedups, notably matching fixed substrings, <code>/i</code> on caseless languages, 64-bit arithmetic, scope overhead'],
		],
		unicode => '8.0',
		release => '2016-05-09',
		distro => {
			debian => '9', # stretch 2017-06
			ubuntu => '17.04', # zesty
			freebsd => '10',
		},
	},

	v5.26 => {
		new => [
			['<code>&lt;&lt;~EOT</code>', 'indented here-docs, strips same whitespace before delimiter in each line'],
			['<code>@{^CAPTURE}</code>', q"array of last match's captures, so <code>${^CAPTURE}[0]</code> is <code>$1</code>"],
			['<code>//xx</code>', 'extended modifier to also ignore whitespace in bracketed character classes'],
		],
		unicode => '9.0', # also Script_Extensions/scx in "\p{script}"
		release => '2017-05-30',
		distro => {
			ubuntu => '17.10', # artful
		},
	},

	v5.28 => {
		new => [
			['<code>delete %hash{…}</code>', 'hash slices can be deleted with key+value pairs'],
			['<code>/(*…)/</code>', 'alphabetic synonyms for assertions, e.g. <code>(*atomic:…)</code> for <code>(?&gt;…)</code> and <code>(*nlb:…)</code> for <code>(?&lt;!…)</code>', {experimental => 'alpha_assertions', stable => v5.31.6}],
			['<code>/(*script_run:)/</code>', 'enforces all characters to be from the same script', {experimental => 'script_run', stable => v5.31.6}],
			['<code>state @a</code>', 'persistent lexical array or hash variables'],
			['<code>perl -i -pe die</code>', 'safe in-place editing: files are replaced only after successful completion'],
			['<code>${^SAFE_LOCALES}</code>', 'locales are thread-safe on supported systems, indicated by this variable'],
		],
		unicode => '10.0',
		release => '2018-06-22',
		distro => {
		},
	},

	v5.30 => {
		new => [
			['<code>/(?<=var+)</code>', 'variable length lookbehind assertions', {experimental => 'vlb'}],
			['<code>m(\p{nv=/.*/})</code>', 'match unicode properties by regular expressions', {experimental => 'uniprop_wildcards'}],
			['<code><s>my $state if 0</s></code>', 'workaround for <code>state</code> (deprecated since v5.10!) is now prohibited'],
			[q"<code>qr'\N'</code>", 'Delimiters must be graphemes; unescaped { illegal; \N in single quotes'],
		],
		unicode => '12.1',
		release => '2019-05-22',
	},

	v5.32 => {
		new => [
			['<code>isa</code>', 'infix operator to check class instance'],
			['<code>$min &lt; $_ &lt;= $max</code>', 'chained comparison repeats inner part as <code>$min &lt; $_ and $_ &lt;= $max</code>'],
			['<code>/\p{Name=$var}/</code>', 'match Unicode Name property like \N{} but with interpolation and subpatterns'],
			[q"<code>open F, '+&gt;&gt;', undef</code>", 'respect append mode on temporary files with mixed access'],
			["<code>no feature 'indirect'</code>", 'disable indirect object notation such as <code>new Class</code> instead of <code>Class-&gt;new</code>'],
			['streamzip', 'program distributed with core IO::Compress::Base to compress stdin into a zip container'],
		],
		unicode => '13.0',
		release => '2020-06-20',
		details => 'https://www.effectiveperlprogramming.com/2020/01/perl-v5-32-new-features/',
	},

	v5.34 => {
		new => [
			['<code>try {} catch</code>', 'exception handling similar to eval blocks', {experimental => 'try'}],
			['<code>/{,<i>n</i>}/</code>', 'empty lower bound quantifier is accepted as shorthand for 0'],
			['<code>\x{ … }</code>', 'insignificant space within curly braces, also for <code>\b{}</code>, <code>\g{}</code>, <code>\k{}</code>, <code>\N{}</code>, <code>\o{}</code> as well as <code>/{m,n}/</code> quantifiers'],
			['<code>0o0</code>', 'octal prefix <code>0o</code> alternative to <code>0…</code> and <code>oct</code>'],
			['<code>re::optimization(qr//)</code>', 'debug regular expression optimization information discovered at compile time'],
		],
		release => '2021-05-20',
	},
}
