use utf8;
(
iso      => [qw{ k  kh g  gh ṅ  c  ch j  jh > ñ  ṭ  ṭh ḍ  ḍh ṇ  t  th d  dh n ṉ  p  ph b  bh m  y  r ṟ  l  ḷ  ḻ  v  ś  ṣ  s  h }],
ipa      => [qw{ k  kʰ ɡ  ɡʱ ŋ  c  cʰ ɟ  ɟʱ > ɲ  ʈ  ʈʰ ɖ  ɖʱ ɳ  t̪  t̪ʰ d̪  d̪ʱ n̪ n  p  pʰ b  bʱ m  j  r ɾ  l  ɭ  ɻ  ʋ  ʃ  ʂ  s  ɦ }],
orya     => [qw{ କ  ଖ  ଗ  ଘ  ଙ  ଚ  ଛ  ଜ  ଝ  > ଞ  ଟ  ଠ  ଡ  ଢ  ଣ  ତ  ଥ  ଦ  ଧ  > ନ  ପ  ଫ  ବ  ଭ  ମ  ଯ  > ର  ଲ  >  ଳ  ଵ  ଶ  ଷ  ସ  ହ }], # <kalinga 10hCE
beng     => [qw{ ক  খ  গ  ঘ  ঙ  চ  ছ  জ  ঝ  > ঞ  ট  ঠ  ড  ঢ  ণ  ত  থ  দ  ধ  > ন  প  ফ  ব  ভ  ম  য  > র/ৰ ল >  -  ৱ  শ  ষ  স  হ }], # <sidd 11hCE
deva     => [qw{ क  ख  ग  घ  ङ  च  छ  ज  झ  > ञ  ट  ठ  ड  ढ  ण  त  थ  द  ध  न ऩ  प  फ  ब  भ  म  य  र ऱ  ल  ळ  ऴ  व  श  ष  स  ह }], # <nagari 13hCE <kalinga 8hCE <brah
gujr     => [qw{ ક  ખ  ગ  ઘ  ઙ  ચ  છ  જ  ઝ  > ઞ  ટ  ઠ  ડ  ઢ  ણ  ત  થ  દ  ધ  > ન  પ  ફ  બ  ભ  મ  ય  > ર  લ  >  ળ  વ  શ  ષ  સ  હ }], # <deva 17hCE
guru     => [qw{ ਕ  ਖ  ਗ  ਘ  ਙ  ਚ  ਛ  ਜ  ਝ  > ਞ  ਟ  ਠ  ਡ  ਢ  ਣ  ਤ  ਥ  ਦ  ਧ  > ਨ  ਪ  ਫ  ਬ  ਭ  ਮ  ਯ  > ਰ  ਲ  >  ਲ਼  ਵ  ਸ਼  -  ਸ  ਹ }], # <sharada 16hCE
tibt     => [qw{ ཀ  ཁ  ག  -  ང  ཅ  ཆ  ཇ  -  > ཉ  ཊ  ཋ  ཌ  -  ཎ  ཏ  ཐ  ད  -  > ན  པ  ཕ  བ  -  མ  ཡ  > ར  ལ  >  -  ཝ  ཤ  ཥ  ས  ཧ }], # <sidd 7hCE
sidd     => [qw{ 𑖎  𑖏  𑖐  𑖑  𑖒  𑖓  𑖔  𑖕  𑖖  > 𑖗  𑖘  𑖙  𑖚  𑖛  𑖜  𑖝  𑖞  𑖟  𑖠  > 𑖡  𑖢  𑖣  𑖤  𑖥  𑖦  𑖧  > 𑖨  𑖩  >  -  𑖪  𑖫  𑖬  𑖭  𑖮 }], # <brah 7hCE
# ↑ northern
brah     => [qw{ 𑀓  𑀔  𑀕  𑀖  𑀗  𑀘  𑀙  𑀚  𑀛  > 𑀜  𑀝  𑀞  𑀟  𑀠  𑀡  𑀢  𑀣  𑀤  𑀥  𑀦 -𑀷 𑀧  𑀨  𑀩  𑀪  𑀫  𑀬  𑀭 -𑀶 𑀮  𑀴  -𑀵 𑀯  𑀰  𑀱  𑀲  𑀳 }],
# ↓ southern
telu     => [qw{ క  ఖ  గ  ఘ  ఙ  చ  ఛ  జ  ఝ  > ఞ  ట  ఠ  డ  ఢ  ణ  త  థ  ద  ధ  > న  ప  ఫ  బ  భ  మ  య  ర ఱ  ల  >  ళ  వ  శ  ష  స  హ }], # 11hCE
knda     => [qw{ ಕ  ಖ  ಗ  ಘ  ಙ  ಚ  ಛ  ಜ  ಝ  > ಞ  ಟ  ಠ  ಡ  ಢ  ಣ  ತ  ಥ  ದ  ಧ  > ನ  ಪ  ಫ  ಬ  ಭ  ಮ  ಯ  ರ ಱ  ಲ  ಳ  ೞ  ವ  ಶ  ಷ  ಸ  ಹ }], # 9hCE
sinh     => [qw{ ක  ඛ  ග  ඝ  ඞ  ච  ඡ  ජ  ඣ  > ඤ  ට  ඨ  ඩ  ඪ  ණ  ත  ථ  ද  ධ  > න  ප  ඵ  බ  භ  ම  ය  > ර  ල  >  ළ  ව  ශ  ෂ  ස  හ }], # <gran 12hCE
mlym     => [qw{ ക  ഖ  ഗ  ഘ  ങ  ച  ഛ  ജ  ഝ  > ഞ  ട  ഠ  ഡ  ഢ  ണ  ത  ഥ  ദ  ധ  ന -ഩ പ  ഫ  ബ  ഭ  മ  യ  ര റ  ല  ള  ഴ  വ  ശ  ഷ  സ  ഹ }], # <gran 12hCE
taml     => [qw{ க  -  -  -  ங  ச  -  ஜ  -  > ஞ  ட  -  -  -  ண  த  -  -  -  ந ன  ப  -  -  -  ம  ய  ர ற  ல  ள  ழ  வ  ஶ  ஷ  ஸ  ஹ }], # 3hCE
mymr     => [qw{ က  ခ  ဂ  ဃ  င  စ  ဆ  ဇ  ဈ  ဉ ည  ဋ  ဌ  ဍ  ဎ  ဏ  တ  ထ  ဒ  ဓ  > န  ပ  ဖ  ဗ  ဘ  မ  ယ  > ရ  လ  ဠ  ၔ  ဝ  ၐ  ၑ  သ  ဟ }], # <gran 11hCE
khmr     => [qw{ ក  ខ  គ  ឃ  ង  ច  ឆ  ជ  ឈ  > ញ  ដ  ឋ  ឌ  ឍ  ណ  ត  ថ  ទ  ធ  > ន  ប  ផ  ព  ភ  ម  យ  > រ  ល  >  -  វ  ឝ  ឞ  ស  ហ }], # <gran 11hCE
thai     => [qw{ ก  ข  ค  ฆ  ง  จ  ฉ  ช  ฌ  > ญ  ฏ  ฐ  ฑ  ฒ  ณ  ต  ถ  ท  ธ  > น  ป  ผ  พ  ภ  ม  ย  > ร  ล  >  -  ว  ศ  ษ  ส  ห }], # <khmr 13hCE
laoo     => [qw{ ກ  ຂ  -  ຄ  ງ  ຈ  ສ  ຊ  -  > ຍ  -  -  -  -  -  ຕ  ຖ  ທ  -  > ນ  ປ  ຜ  ຟ  ພ  ມ  ຢ  > ຣ  ລ  >  -  ວ  -  -  -  ຫ }], # <khmr 14hCE
tglg     => [qw{ ᜃ  -  ᜄ  -  ᜅ  -  -  -  -  > -  -  -  -  -  -  ᜆ  -  ᜇ  -  > ᜈ  ᜉ  -  ᜊ  -  ᜋ  ᜌ  > ᜇ  ᜎ  >  -  -  -  -  ᜐ  ᜑ }], # <kawi 14hCE
);
